 !Entry by carl Barnes, carl@carlbarnes.com

   program

   map
      main
   end

!------------------------------------------------------------!
! You may not make any changes to DelimQueue or
! ParserBaseClass.
! well if you want to use a different method then you should
! get to remove the DelimQ stuff
!------------------------------------------------------------!
DelimQueue           queue
Delim                   string(1)
                     end

ParserBaseClass      class,type
DelimQ                  &DelimQueue
Text                    string(1000)
!--- methods ------------------------------------------------!
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetString               procedure,string,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
Init                    procedure
Kill                    procedure
PutToken                procedure(long Index,string Text),byte,virtual,proc
Reset                   procedure,virtual
SetString               procedure(string Text),virtual
!------------------------------------------------------------!
! Do NOT derive the Test procedure. All derived classes
! have to use the base class's test.
!------------------------------------------------------------!
Test                    procedure
Test2                   procedure
                     end

!------------------------------------------------------------!
! MyParser is the class declaration you can make changes to
! if you wish. You may want to add variables to this class.
!------------------------------------------------------------!
MyParser             class(ParserBaseClass)
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
PutToken                procedure(long Index,string Text),byte,virtual,proc
 !Carl Additions
Init                    procedure
Reset                   procedure,virtual,derived
Kill                    procedure
ParseCount              LONG
ParseStart              LONG,DIM(500),AUTO
ParseEnd                LONG,DIM(500),AUTO
DelimMap                BYTE,DIM(256),AUTO
TextLen                 LONG,AUTO
                     end

   code
   main()



main     procedure

    map
    end

Count       Long
Ending      Long
NextDay     long
Starting    Long
x           short

ResultsQ    queue
Name           string(30)
Elapsed        decimal(5,2)
Text           string(1000)
Index          byte
            end


Window WINDOW('Parser Test'),AT(,,422,108),FONT('MS Sans Serif',7,,FONT:regular),CENTER,ICON('Clarion.ico'), |
         GRAY,DOUBLE
       PROMPT('No. Of Tests:'),AT(4,7),USE(?Prompt4)
       SPIN(@n9),AT(56,7,60,10),USE(Count)
       LIST,AT(4,23,409,65),USE(?List1),HSCROLL,FORMAT('90L(2)|M~Name~@s30@31L(2)|M~Elapsed~@n5.2@20L(2)|M~Result~@s255@'), |
           FROM(ResultsQ)
       BUTTON('&Calculate'),AT(119,92,45,14),USE(?Calculate),DEFAULT
       BUTTON('C&lose'),AT(257,92,45,14),USE(?Close),STD(std:close)
     END

StartTime      ulong
EndTime        ulong
 
   Code
   Count = 2000
   MyParser.Init()
   clear(ResultsQ)
   ResultsQ.Index = 1
   ResultsQ.Name = 'Test 1'
   add(ResultsQ)
   clear(ResultsQ)
   ResultsQ.Index = 2
   ResultsQ.Name = 'Test 2'
   add(ResultsQ)
   Open(Window)
   post(event:accepted,?Calculate)
   Accept
      Case accepted()
      of ?Calculate
         setcursor(cursor:wait)
         sort(ResultsQ,ResultsQ.Index)
         loop x = 1 to records(ResultsQ)
            get(ResultsQ,x)
            StartTime = clock()
            loop Count times
               execute x
                  MyParser.Test()
                  MyParser.Test2()
               end
            end
            ResultsQ.Text = MyParser.GetString()
            ResultsQ.Elapsed = (clock() - StartTime)/100
            put(ResultsQ)
            setclipboard(ResultsQ.Text)
         end
         sort(ResultsQ,ResultsQ.Elapsed)
         setcursor()
         display()
      end
   end
   MyParser.Kill()



!!--- methods ------------------------------------------------!
ParserBaseClass.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.BeforeTest              procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.GetString               procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(self.Text)

ParserBaseClass.GetTokenCount           procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(0)

ParserBaseClass.GetToken                procedure(long Index)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return('')


ParserBaseClass.Init                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.DelimQ &= new DelimQueue

ParserBaseClass.Kill                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   free(self.DelimQ)
   dispose(self.DelimQ)

ParserBaseClass.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(False)

ParserBaseClass.Reset                   procedure
   code
   free(self.DelimQ)
   clear(self.Text)

ParserBaseClass.SetString               procedure(string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.Text = Text

ParserBaseClass.Test                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.SetString('This is the test string, which should have its words alternating between '|
      & 'upper case and lower case. The actual test will parse Clarion code and capitalize keywords.')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      if x % 2
         TempString = upper(TempString)
      else
         TempString = lower(TempString)
      end
      self.PutToken(x,TempString)
   end
   return

ParserBaseClass.Test2                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.AddDelimiter('.')
   self.AddDelimiter('&')
   self.AddDelimiter('(')
   self.AddDelimiter(')')
   self.AddDelimiter('=')
   self.AddDelimiter(',')
   self.AddDelimiter('-')
   self.AddDelimiter('+')
   self.SetString('self.Text=sub(self.Text,1,self.TokenQ.Start-1)&clip(Text)&sub(self.Text,self.TokenQ.Finish+1,Len(Self.Text))')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      case upper(TempString)
      of 'SELF'
      orof 'SUB'
      orof 'CLIP'
      orof 'LEN'
         TempString = upper(TempString)
         self.PutToken(x,TempString)
      end
   end
   return

!------------------------------------------------------------!
! You may not modify anything above this point except for
! the MyParser class declaration at the top of the file.
!------------------------------------------------------------!


!Carl Barnes notes:
!My approach allows for multiple delimeters in a row that are ignored
!so if there is a double space it still works
!
!I replaced the Delimiter Queue with my own method and so got rid of
!that code.
!
!I would have liked to have added a BYTEs version of the Text to the base class
!to avoid the VAL()'s
!
!I put in ASSERTs to check for possible problems, please test with Debug Off

MyParser.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! You don't need to modify this method but you may wish to
! if you have a better idea for how to store delimiters.
! By default this method adds records to the DelimQ. To get
! the delimiters that have been added you can query the queue
! as you would any other queue. If you have questions about
! this email advisor@clarionmag.com.
!------------------------------------------------------------!
   code
   SELF.DelimMap[ VAL(Delim)+1 ] = True

!   self.DelimQ.Delim = Delim
!   add(self.DelimQ)

MyParser.BeforeTest              procedure
!------------------------------------------------------------!
! Write code here to prepare for the test, if necessary.
! This method is called automatically by the test procedure
! before the test is run. You will most likely want to use
! this method if you parse your string before calling any of
! the string manipulation methods. If you do everything
! on the fly then you probably won't need this method
!------------------------------------------------------------!

I           LONG,AUTO
TextStart   LONG,AUTO           !The Byte at which non-delimiter text started
   code

   !--Parse the string and store positions in the ParseStart[] and ParseEnd[] Arrays
   !  this code handles multple delimiters in a row
   !  since the Text string is fixed at 1000 the max possible delimited strings is 500
   SELF.ParseCount = 0          !no need to Clear(Start/End[])
   TextStart = 0
   SELF.TextLen = LEN(CLIP(SELF.Text))
   LOOP I = 1 TO SELF.TextLen

        IF SELF.DelimMap[ VAL(Self.Text[I])+1 ]         !Is this a Delimiter Character
           DO AddParseRtn                               ! then add to the parse list (maybe)
        ELSIF NOT TextStart                             !It's not a delimiter, IF NOT in the middle of delimited text
              TextStart = I                             !  mark this as the start of a new text block
        END

   END !LOOP I

   DO AddParseRtn

AddParseRtn ROUTINE     !Add Textstart and I-1 as text in ParseStart/End[]

   IF TextStart
      SELF.ParseCount += 1                      ! then add it to the parse list
?     ASSERT(SELF.ParseCount <= MAXIMUM(SELF.ParseStart[],1) )
      SELF.ParseStart[SELF.ParseCount] = TextStart
      SELF.ParseEnd[SELF.ParseCount]   = I-1   
      TextStart = 0                             ! flag that we are no longer in the middle of Text
   END

MyParser.GetTokenCount           procedure
!------------------------------------------------------------!
! Write code here to count the number of tokens. By default
! you have a queue (self.DelimQ) of delimiters which you
! can use to examine the text string (self.Text).
!------------------------------------------------------------!
   code
   RETURN(SELF.ParseCount)  ! Replace this code!

MyParser.GetToken                procedure(long Index)
!------------------------------------------------------------!
! Write code here to get a specific token. In the example
! text a token is an individual words, but if the string
! were some Clarion code and the period is a delimiter then
! if the string were "MyParser.GetToken" GetToken(1) would
! return "MyParser" and GetToken(2) would return "GetToken"
!------------------------------------------------------------!
   code
?  ASSERT(Index <= SELF.ParseCount)
?  ASSERT(Index > 0)
   RETURN(SELF.Text[ SELF.ParseStart[Index] : SELF.ParseEnd[Index] ] )

MyParser.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! Write code here to set a specified token in the string to
! a new value. For instance, if the string is
! "MyParser.GetToken" and the period is a delimiter then
! calling PutToken(1,'SomeOtherParser') would change the
! string to "SomeOtherParser.GetToken".
!------------------------------------------------------------!
PutLen     LONG,AUTO
DiffLen    LONG,AUTO
AssignEnd  LONG,AUTO
I          LONG,AUTO
   code
   IF Index > SELF.ParseCount THEN Return(False).
?  ASSERT(Index > 0)
   PutLen = LEN(CLIP(Text))
?  ASSERT(PutLen)                       !Null replace not supported
   DiffLen = PutLen - (SELF.ParseEnd[Index] - SELF.ParseStart[Index] + 1)
   IF NOT DiffLen                       !Same size token, then it's a simple replace
      SELF.Text[ SELF.ParseStart[Index] : SELF.ParseEnd[Index] ] = Text
   ELSE                                 !Token size changed, clean up the mess
      IF DiffLen < 0                    !Is the new string smaller than the original?
         AssignEnd = SELF.TextLen       !assign out to the old end so trailing spaces get cleared
      ELSE                              !Else the new string is longer
         AssignEnd = SELF.TextLen + DiffLen
?        ASSERT(AssignEnd <= SIZE(Self.Text) )
      END
      SELF.Text[ SELF.ParseStart[Index] : AssignEnd ] = Text[1 : PutLen] & |
                                                      SELF.Text[ SELF.ParseEnd[Index]+1 : SELF.TextLen ]
      SELF.ParseEnd[Index] += DiffLen
      SELF.TextLen         += DiffLen
      LOOP I = Index + 1 TO SELF.ParseCount    !Adjust all subsequent positions
           SELF.ParseStart[I] += DiffLen
           SELF.ParseEnd[I]   += DiffLen
      END
   END
   RETURN(True)

!--Extra overridden/derived methods
MyParser.Reset                   procedure
   code
   PARENT.Reset
   CLEAR(SELF.DelimMap[])

MyParser.Init                    procedure
   code
!   PARENT.INIT

MyParser.Kill                    procedure
   code
!   PARENT.KILL


