   program

   map
      main
   end


!------------------------------------------------------------!
! You may not make any changes to DelimQueue or
! ParserBaseClass.
!------------------------------------------------------------!
DelimQueue           queue
Delim                   string(1)
                     end

ParserBaseClass      class,type
DelimQ                  &DelimQueue
Text                    string(1000)
!--- methods ------------------------------------------------!
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetString               procedure,string,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
Init                    procedure
Kill                    procedure
PutToken                procedure(long Index,string Text),byte,virtual,proc
Reset                   procedure,virtual
SetString               procedure(string Text),virtual
!------------------------------------------------------------!
! Do NOT derive the Test procedure. All derived classes
! have to use the base class's test.
!------------------------------------------------------------!
Test                    procedure
Test2                   procedure
                     end

!------------------------------------------------------------!
! MyParser is the class declaration you can make changes to
! if you wish. You may want to add variables to this class.
!------------------------------------------------------------!
TokenQType           QUEUE,TYPE                              ! Used to store token locations
AlphaPos               LONG                                  !   Token starts here ...
OmegaPos               LONG                                  !   ... and ends here
                     END

MyParser             class(ParserBaseClass)
!--- Properties ---------------------------------------------!
TokenQ                  &TokenQType,PRIVATE                  ! Used to store token locations
WhiteSpaceChars         CSTRING(256),PROTECTED               ! Trailing Characters to be ignored
Delims                  CSTRING(256),PROTECTED               ! Delimiting Characters
!--- Methods ------------------------------------------------!
Construct               PROCEDURE,PRIVATE
Destruct                PROCEDURE,PRIVATE
AddDelimiter            PROCEDURE(STRING Delim),virtual
GetToken                PROCEDURE(LONG Index),STRING,VIRTUAL
GetTokenCount           PROCEDURE,LONG,VIRTUAL
ParseString             PROCEDURE,PROC,LONG         ! Returns 0 if successful, errorcode otherwise
PutToken                PROCEDURE(LONG Index, STRING Text),BYTE,VIRTUAL,PROC
Reset                   PROCEDURE,VIRTUAL
SetString               PROCEDURE(STRING Text),VIRTUAL
                     end


   code
   main()



main     procedure



    map
    end

Count       Long
Ending      Long
NextDay     long
Starting    Long
x           short

ResultsQ    queue
Name           string(30)
Elapsed        decimal(5,2)
Text           string(1000)
Index          byte
            end



Window WINDOW('Parser Test'),AT(,,422,108),FONT('MS Sans Serif',7,,FONT:regular),CENTER,ICON('Clarion.ico'), |
         GRAY,DOUBLE
       PROMPT('No. Of Tests:'),AT(4,7),USE(?Prompt4)
       SPIN(@n9),AT(56,7,60,10),USE(Count)
       LIST,AT(4,23,409,65),USE(?List1),HSCROLL,FORMAT('90L(2)|M~Name~@s30@31L(2)|M~Elapsed~@n5.2@20L(2)|M~Result~@s255@'), |
           FROM(ResultsQ)
       BUTTON('&Calculate'),AT(119,92,45,14),USE(?Calculate),DEFAULT
       BUTTON('C&lose'),AT(257,92,45,14),USE(?Close),STD(std:close)
     END

StartTime      ulong
EndTime        ulong
 
   Code
   Count = 2000
   MyParser.Init()
   clear(ResultsQ)
   ResultsQ.Index = 1
   ResultsQ.Name = 'Test 1'
   add(ResultsQ)
   clear(ResultsQ)
   ResultsQ.Index = 2
   ResultsQ.Name = 'Test 2'
   add(ResultsQ)
   Open(Window)
   post(event:accepted,?Calculate)
   Accept
      Case accepted()
      of ?Calculate
         setcursor(cursor:wait)
         sort(ResultsQ,ResultsQ.Index)
         loop x = 1 to records(ResultsQ)
            get(ResultsQ,x)
            StartTime = clock()
            loop Count times
               execute x
                  MyParser.Test()
                  MyParser.Test2()
               end
            end
            ResultsQ.Text = MyParser.GetString()
            ResultsQ.Elapsed = (clock() - StartTime)/100
            put(ResultsQ)
            setclipboard(ResultsQ.Text)
         end
         sort(ResultsQ,ResultsQ.Elapsed)
         setcursor()
         display()
      end
   end
   MyParser.Kill()



!!--- methods ------------------------------------------------!
ParserBaseClass.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.BeforeTest              procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.GetString               procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(self.Text)

ParserBaseClass.GetTokenCount           procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(0)

ParserBaseClass.GetToken                procedure(long Index)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return('')


ParserBaseClass.Init                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.DelimQ &= new DelimQueue

ParserBaseClass.Kill                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   free(self.DelimQ)
   dispose(self.DelimQ)

ParserBaseClass.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(False)

ParserBaseClass.Reset                   procedure
   code
   free(self.DelimQ)
   clear(self.Text)

ParserBaseClass.SetString               procedure(string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.Text = Text

ParserBaseClass.Test                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.SetString('This is the test string, which should have its words alternating between '|
      & 'upper case and lower case. The actual test will parse Clarion code and capitalize keywords.')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      if x % 2
         TempString = upper(TempString)
      else
         TempString = lower(TempString)
      end
      self.PutToken(x,TempString)
   end
   return

ParserBaseClass.Test2                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.AddDelimiter('.')
   self.AddDelimiter('&')
   self.AddDelimiter('(')
   self.AddDelimiter(')')
   self.AddDelimiter('=')
   self.AddDelimiter(',')
   self.AddDelimiter('-')
   self.AddDelimiter('+')
   self.SetString('self.Text=sub(self.Text,1,self.TokenQ.Start-1)&clip(Text)&sub(self.Text,self.TokenQ.Finish+1,Len(Self.Text))')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      case upper(TempString)
      of 'SELF'
      orof 'SUB'
      orof 'CLIP'
      orof 'LEN'
         TempString = upper(TempString)
         self.PutToken(x,TempString)
      end
   end
   return

!------------------------------------------------------------!
! You may not modify anything above this point except for
! the MyParser class declaration at the top of the file.
!------------------------------------------------------------!


MyParser.Construct PROCEDURE
  CODE
  Self.TokenQ &= NEW TokenQType
  Self.WhiteSpaceChars = ' '
  RETURN

MyParser.Destruct PROCEDURE
  CODE
  DISPOSE(Self.TokenQ)
  RETURN

MyParser.AddDelimiter PROCEDURE(STRING Delim)
  CODE
  Self.Delims = Self.Delims & Delim
  Self.ParseString
  RETURN

MyParser.GetTokenCount PROCEDURE
  CODE
  RETURN RECORDS(Self.TokenQ)

MyParser.GetToken PROCEDURE(LONG Index)
  CODE
  GET(Self.TokenQ, Index)
  IF ErrorCode() THEN RETURN ''.
  RETURN Self.Text[Self.TokenQ.AlphaPos : Self.TokenQ.OmegaPos]

MyParser.ParseString PROCEDURE
TokenPos         LONG,AUTO                     ! holds a token position
Ndx              LONG,AUTO                     ! generic index
Ptr              LONG,AUTO                     ! points to a queue entry (speed)
RecCnt           LONG,AUTO                     ! number of records in a queue (speed)
StrLen           LONG,AUTO                     ! length of SubjectString (speed)
WS               LONG,AUTO                     ! used for skipping Whitespace
  CODE
  FREE(Self.TokenQ)
  IF Self.Text = '' THEN RETURN False.
  TokenPos = 1

  StrLen = CHOOSE(INSTRING(' ', Self.WhiteSpaceChars, 1) > 0, LEN(CLIP(Self.Text)), LEN(Self.Text))
  LOOP Ptr = 1 TO StrLen BY 1
    IF INSTRING(Self.Text[ptr : ptr], Self.Delims, 1) THEN
      Self.TokenQ.AlphaPos = TokenPos
      Self.TokenQ.OmegaPos = Ptr - 1
      ADD(Self.TokenQ)
      IF ErrorCode() THEN RETURN ErrorCode().
      LOOP Ptr = Ptr + 1 TO StrLen BY 1
      UNTIL INSTRING(Self.Text[ptr : ptr], Self.WhiteSpaceChars, 1)=0
      TokenPos = Ptr
    END
  END

  IF TokenPos <= StrLen THEN
    Self.TokenQ.AlphaPos = TokenPos
    Self.TokenQ.OmegaPos = StrLen
    ADD(Self.TokenQ)
    IF ErrorCode() THEN RETURN ErrorCode().
  END
  RETURN False

MyParser.PutToken PROCEDURE(LONG Index, STRING Text)
DiffLen          LONG,AUTO                     ! difference in length from old/new token
OutsideLeft      LONG,AUTO                     ! position to the left of the token (speed)
OutsideRight     LONG,AUTO                     ! position to the right of the token (speed)
Ptr              LONG,AUTO                     ! points to a queue entry (speed)
EndPtr           LONG,AUTO                     ! number of records in a queue (speed)
TextLen          LONG,AUTO                     ! Length of Self.Text (speed)
   CODE
   GET(Self.TokenQ, Index)
   IF ErrorCode() THEN RETURN ErrorCode().
   DiffLen    = LEN(CLIP(Text)) - (Self.TokenQ.OmegaPos - Self.TokenQ.AlphaPos + 1)
   TextLen    = LEN(Self.Text)
                    
   OutsideLeft         = Self.TokenQ.AlphaPos - 1
   OutsideRight        = Self.TokenQ.OmegaPos + 1
   Self.Text           = CHOOSE(OutsideLeft>0, Self.Text[1 : OutsideLeft], '') |
                       & CLIP(Text) |
                       & CHOOSE(OutsideRight>TextLen, '', Self.Text[OutsideRight : TextLen])

   IF DiffLen=0 THEN RETURN False.

   Self.TokenQ.OmegaPos   += DiffLen
   IF Self.TokenQ.OmegaPos > TextLen THEN
     Self.TokenQ.OmegaPos = TextLen
   END
   PUT(Self.TokenQ)

   EndPtr  = POINTER(Self.TokenQ)+1
   LOOP Ptr = RECORDS(Self.TokenQ) TO EndPtr BY -1
     GET(Self.TokenQ, Ptr)
     Self.TokenQ.AlphaPos += DiffLen
     Self.TokenQ.OmegaPos += DiffLen
     IF Self.TokenQ.AlphaPos > TextLen THEN
       DELETE(Self.TokenQ)
     ELSIF Self.TokenQ.OmegaPos > TextLen THEN
       Self.TokenQ.OmegaPos = TextLen
     END
     PUT(Self.TokenQ)
   END
   RETURN False

MyParser.Reset PROCEDURE
  CODE
  Parent.Reset
  Self.Delims = ''
  RETURN

MyParser.SetString PROCEDURE(STRING Text)
  CODE
  Parent.SetString(Text)
  Self.ParseString
  RETURN
