   program

! Version from P. Will -- ProDomus, Inc. 74650.3623@compuserve.com
! Revised 6/26/99

!------------------------------------------------------------!
! Some coding options tested                                 !

eDelimit    EQUATE(4)    ! Different methods for IsDelimiter
                         ! 1 - DelimitQ
                         ! 2 - String constant using INSTRING
                         ! 3 - String constant using string slicing -4.5 sec
                         ! 4 - Only one delimiter used per test case (The fastest) -.1 sec

eToken      EQUATE(0)    ! TokenQ definitions (reference string vs. string slicing)
                         ! 0 (string slice) about -.2

eTokenArray EQUATE(0)    ! Use array instead of Q. +12.5 seconds
eLeft       EQUATE(1)
eRight      EQUATE(2)
!------------------------------------------------------------!
   map
      main
   end


!------------------------------------------------------------!
! You may not make any changes to DelimQueue or
! ParserBaseClass.
!------------------------------------------------------------!

! <<>> psw added TYPE attribute, removed from final solution
DelimQueue           queue,TYPE 
Delim                   string(1)
                     end
! <<>> psw added token Queue, tried array

  OMIT('@END',eTokenArray)
TokenQueue           QUEUE,TYPE
    COMPILE('@@',eToken)
Token                  &STRING
    @@
    OMIT('@@',eToken)
Left                   SIGNED
Right                  SIGNED
    @@
                     END
  @END

ParserBaseClass      class,type
DelimQ                  &DelimQueue
Text                    string(1000)
!--- methods ------------------------------------------------!
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetString               procedure,string,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
Init                    procedure
Kill                    procedure
PutToken                procedure(long Index,string Text),byte,virtual,proc
Reset                   procedure,virtual
SetString               procedure(string Text),virtual
!------------------------------------------------------------!
! Do NOT derive the Test procedure. All derived classes
! have to use the base class's test.
!------------------------------------------------------------!
Test                    procedure
Test2                   procedure
                     end

!------------------------------------------------------------!
! MyParser is the class declaration you can make changes to
! if you wish. You may want to add variables to this class.
!------------------------------------------------------------!
MyParser             class(ParserBaseClass)
!-- new
Delimiters              STRING(' ')                     ! pw added one line.  could have more, i.e. STRING(' ,''.')
  OMIT('@@',eTokenArray)
TokenQ                  &TokenQueue
  @@
  COMPILE('@END',eTokenArray)
TokenArray              SIGNED,DIM(333,2)
Ndx                     SIGNED
  @END
Init                    PROCEDURE
IsDelimiter             PROCEDURE(STRING P:Str),BYTE
SetString               PROCEDURE(STRING Text),virtual
Reset                   PROCEDURE,VIRTUAL
!-- end new
AddDelimiter            procedure(string Delim),virtual
BeforeTest              procedure,virtual
GetTokenCount           procedure,long,virtual
GetToken                procedure(long Index),string,virtual
PutToken                procedure(long Index,string Text),byte,virtual,proc
                     end


   code
   main()



main     procedure



    map
    end

Count       Long
Ending      Long
NextDay     long
Starting    Long
x           short

ResultsQ    queue
Name           string(30)
Elapsed        decimal(5,2)
Text           string(1000)
Index          byte
            end



Window WINDOW('Parser Test'),AT(,,422,108),FONT('MS Sans Serif',7,,FONT:regular),CENTER,ICON('Clarion.ico'), |
         GRAY,DOUBLE
       PROMPT('No. Of Tests:'),AT(4,7),USE(?Prompt4)
       SPIN(@n9),AT(56,7,60,10),USE(Count)
       LIST,AT(4,23,409,65),USE(?List1),HSCROLL,FORMAT('90L(2)|M~Name~@s30@31L(2)|M~Elapsed~@n5.2@20L(2)|M~Result~@s255@'), |
           FROM(ResultsQ)
       BUTTON('&Calculate'),AT(119,92,45,14),USE(?Calculate),DEFAULT
       BUTTON('C&lose'),AT(257,92,45,14),USE(?Close),STD(std:close)
     END

StartTime      ulong
EndTime        ulong
 
   Code
   Count = 2000
   MyParser.Init()
   clear(ResultsQ)
   ResultsQ.Index = 1
   ResultsQ.Name = 'Test 1'
   add(ResultsQ)
   clear(ResultsQ)
   ResultsQ.Index = 2
   ResultsQ.Name = 'Test 2'
   add(ResultsQ)
   Open(Window)
   post(event:accepted,?Calculate)
   Accept
      Case accepted()
      of ?Calculate
         setcursor(cursor:wait)
         sort(ResultsQ,ResultsQ.Index)
         loop x = 1 to records(ResultsQ)
            get(ResultsQ,x)
            StartTime = clock()
            loop Count times
               execute x
                  MyParser.Test()
                  MyParser.Test2()
               end
            end
            ResultsQ.Text = MyParser.GetString()
            ResultsQ.Elapsed = (clock() - StartTime)/100
            put(ResultsQ)
            setclipboard(ResultsQ.Text)
         end
         sort(ResultsQ,ResultsQ.Elapsed)
         setcursor()
         display()
      end
   end
   MyParser.Kill()



!!--- methods ------------------------------------------------!
ParserBaseClass.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.BeforeTest              procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code

ParserBaseClass.GetString               procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(self.Text)

ParserBaseClass.GetTokenCount           procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(0)

ParserBaseClass.GetToken                procedure(long Index)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return('')


ParserBaseClass.Init                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.DelimQ &= new DelimQueue

ParserBaseClass.Kill                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   free(self.DelimQ)
   dispose(self.DelimQ)

ParserBaseClass.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   return(False)

ParserBaseClass.Reset                   procedure
   code
   free(self.DelimQ)
   clear(self.Text)

ParserBaseClass.SetString               procedure(string Text)
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!!
!------------------------------------------------------------!
   code
   self.Text = Text

ParserBaseClass.Test                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.SetString('This is the test string, which should have its words alternating between '|
      & 'upper case and lower case. The actual test will parse Clarion code and capitalize keywords.')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      if x % 2
         TempString = upper(TempString)
      else
         TempString = lower(TempString)
      end
      self.PutToken(x,TempString)
   end
   return

ParserBaseClass.Test2                    procedure
!------------------------------------------------------------!
! DO NOT MODIFY THIS METHOD!!! And do NOT derive it.
!------------------------------------------------------------!
TempString  string(200)
x           long
   code
   self.Reset()
   self.AddDelimiter(' ')
   self.AddDelimiter('.')
   self.AddDelimiter('&')
   self.AddDelimiter('(')
   self.AddDelimiter(')')
   self.AddDelimiter('=')
   self.AddDelimiter(',')
   self.AddDelimiter('-')
   self.AddDelimiter('+')
   self.SetString('self.Text=sub(self.Text,1,self.TokenQ.Start-1)&clip(Text)&sub(self.Text,self.TokenQ.Finish+1,Len(Self.Text))')
   self.BeforeTest()
   loop x = 1 to self.GetTokenCount()
      TempString = self.GetToken(x)
      case upper(TempString)
      of 'SELF'
      orof 'SUB'
      orof 'CLIP'
      orof 'LEN'
         TempString = upper(TempString)
         self.PutToken(x,TempString)
      end
   end
   return

!------------------------------------------------------------!
! You may not modify anything above this point except for
! the MyParser class declaration at the top of the file.
!------------------------------------------------------------!
MyParser.Init PROCEDURE
!------------------------------------------------------------!
  CODE
  COMPILE('@@',eDelmit=1)
    PARENT.Init
  !@@
  OMIT('@@',etokenArray)
    Self.TokenQ &= NEW TokenQueue
  @@
! Don't need a the queue
  

MyParser.AddDelimiter            procedure(string Delim)
!------------------------------------------------------------!
! You don't need to modify this method but you may wish to
! if you have a better idea for how to store delimiters.
! By default this method adds records to the DelimQ. To get
! the delimiters that have been added you can query the queue
! as you would any other queue. If you have questions about
! this email advisor@clarionmag.com.
!------------------------------------------------------------!
   code

   !-- Delimiter defined in the data
   OMIT('@@')
   self.DelimQ.Delim = Delim
   add(self.DelimQ)
   @@
   !-- Another approach (not used here)
   OMIT('@@')
   !-- If you want to be able to set the delimit string at run time.
   !-- Redefine the delimit string to &STRING
   SELF.Delimiters &= NEW STRING(LEN(Delim))
   SELF.Delimiters=Delim
   ! then dispose it in the kill method.
   !@@

MyParser.BeforeTest              procedure
!------------------------------------------------------------!
! Write code here to prepare for the test, if necessary.
! This method is called automatically by the test procedure
! before the test is run. You will most likely want to use
! this method if you parse your string before calling any of
! the string manipulation methods. If you do everything
! on the fly then you probably won't need this method
!------------------------------------------------------------!
   code

MyParser.GetTokenCount           procedure
!------------------------------------------------------------!
! Write code here to count the number of tokens. By default
! you have a queue (self.DelimQ) of delimiters which you
! can use to examine the text string (self.Text).
!------------------------------------------------------------!
   code
   COMPILE('@@',eTokenArray)
     RETURN SELF.Ndx
   @@
   OMIT('@@',eTokenArray)
     RETURN Records(SELF.TokenQ)
   @@

MyParser.GetToken                procedure(long Index)
!------------------------------------------------------------!
! Write code here to get a specific token. In the example
! text a token is an individual words, but if the string
! were some Clarion code and the period is a delimiter then
! if the string were "MyParser.GetToken" GetToken(1) would
! return "MyParser" and GetToken(2) would return "GetToken"
!------------------------------------------------------------!
   code
   OMIT('@END',eTokenArray)
     GET(SELF.TokenQ,INDEX)
     COMPILE('@@',eToken)
     RETURN SELF.TokenQ.Token
     !@@
     OMIT('@@',eToken)
     RETURN SELF.Text[SELF.TokenQ.Left : SELF.TokenQ.Right]
     !@@
   @END
   COMPILE('@@',eTokenArray)
     RETURN SELF.Text[SELF.TokenArray[Index,eLeft] : SELF.TokenArray[Index,eRight]]
   @@

   !return('')  ! Replace this code!

MyParser.PutToken                procedure(long Index,string Text)
!------------------------------------------------------------!
! Write code here to set a specified token in the string to
! a new value. For instance, if the string is
! "MyParser.GetToken" and the period is a delimiter then
! calling PutToken(1,'SomeOtherParser') would change the
! string to "SomeOtherParser.GetToken".
!------------------------------------------------------------!
   code
   OMIT('@END',eTokenArray)
     GET(SELF.TokenQ,Index)
     IF NOT ERRORCODE()
       COMPILE('@@',eToken)
       SELF.TokenQ.Token=Text
       PUT(SELF.TokenQ)
       !@@
       OMIT('@@',eToken)
       SELF.Text[SELF.TokenQ.Left : SELF.TokenQ.Right]=Text
       !@@
       RETURN TRUE
     END
     return(False)  ! Replace this code!
   @END
   COMPILE('@@',eTokenArray)
     SELF.Text[SELF.TokenArray[Index,eLeft] : SELF.TokenArray[Index,eRight]]=Text
     RETURN TRUE
   @@

!------------------------------------------------------------!
MyParser.IsDelimiter PROCEDURE(STRING P:Str)
!------------------------------------------------------------!
  COMPILE('@@',eDelimit=1)
rv  BYTE
    CODE
    LOOP I#=1 TO RECORDS(SELF.DelimQ)
      GET(SELF.DelimQ,I#)
      IF SELF.DelimQ.Delim=P:Str
        RV=TRUE
        BREAK
      END
    END
    RETURN RV
  !@@ Case 1  5.17-5.22 seconds

  COMPILE('@@',eDelimit=2)
    CODE
    RETURN INSTRING(P:Str,SELF.Delimiters,1,1)
  !@@ Case 2  .71 to .77 secons (mostly .77)

  COMPILE('@@',eDelimit=3)
Cnt SIGNED,AUTO
    CODE
    LOOP Cnt = 1 TO LEN(SELF.Delimiters)
      IF P:Str=SELF.Delimiters[Cnt]
        RETURN 1
      END
    END
    RETURN 0
  !@@ Case 3  .71 to .77 secons.  Mostly .71/.72

  COMPILE('@@',eDelimit=4)
  !-- Optimized for test procedure (one delimiter)
    CODE
    RETURN CHOOSE(SELF.Delimiters=P:Str,1,0)
  !@@ Case 4

!------------------------------------------------------------!
MyParser.Reset PROCEDURE
!------------------------------------------------------------!
  CODE
  Parent.reset
  OMIT('@@',eTokenArray)
    FREE(SELF.TokenQ)
  @@
  COMPILE('@@',eTokenArray)
    CLEAR(SELF.TokenArray)
  @@

!------------------------------------------------------------!
MyParser.SetString PROCEDURE(STRING P:Str)
!------------------------------------------------------------!
Found        SIGNED
!TokenG       GROUP,PRE() !Slower
Cnt            SIGNED(0) !,AUTO slower start up
Len            SIGNED,AUTO
!             END
  CODE
  SELF.Text=P:Str
  Len=LEN(CLIP(SELF.Text))
  !Cnt=1
  ! LOOP I#=1 TO LEN(CLIP(SELF.Text)) ! Slower
  ! LOOP WHILE Cnt<=Len ! About the same speed as the one used
  LOOP
    Cnt += 1
    IF Cnt>=len
      IF Found
        OMIT('@END',eTokenArray)
          COMPILE('@@',eToken) ! Slower
            SELF.TokenQ.Token &= SELF.Text[Found : Cnt]
          @@
          OMIT('@@',eToken)
            SELF.TokenQ.Left=Found
            SELF.TokenQ.Right=Cnt
            ! SELF.TokenQ=TokenG ! Slower
          @@
        ADD(SELF.TokenQ)
        @END
        COMPILE('@@',etokenArray)
          SELF.Ndx += 1
          SELF.TokenArray[SELF.Ndx,eLeft]=Found
          SELF.TokenArray[SELF.Ndx,eRight]=Cnt
        @@
      ELSIF Len=1 AND NOT SELF.IsDelimiter(SELF.Text[1])
        OMIT('@END',eTokenArray)
          COMPILE('@@',eToken) ! Slower
            SELF.TokenQ.Token &= SELF.Text[1]
          @@
          OMIT('@@',eToken)
            SELF.TokenQ.Left=1
            SELF.TokenQ.Right=1
          @@
          ADD(SELF.TokenQ)
        @END
        COMPILE('@@',etokenArray)
          SELF.Ndx += 1
          SELF.TokenArray[SELF.Ndx,eLeft]=Found
          SELF.TokenArray[SELF.Ndx,eRight]=Cnt
        @@
      ELSIF NOT SELF.IsDelimiter(SELF.Text[Cnt])
        OMIT('@@',etokenArray)
          SELF.TokenQ.Left=Cnt
          SELF.TokenQ.right=Cnt
          ADD(SELF.TokenQ)
        @@
      END
      BREAK
    ELSIF SELF.IsDelimiter(SELF.Text[Cnt])
      IF Found
        OMIT('@END',eTokenArray)
          COMPILE('@@',eToken)
            SELF.TokenQ.Token &= SELF.Text[Found : Cnt]
          !@@
          OMIT('@@',eToken)
            SELF.TokenQ.Left=Found
            SELF.TokenQ.Right=Cnt
          !@@
          ADD(SELF.TokenQ)
        @END
        COMPILE('@@',eTokenArray)
          SELF.Ndx += 1
          SELF.TokenArray[SELF.Ndx,eLeft]=Found
          SELF.TokenArray[SELF.Ndx,eRight]=Cnt
        @@
        Found=0
      END
    ELSIF NOT Found
        Found=Cnt
    END
  END

